## mingw-w64-frontistr-5.6-2.src.tar.zst

=== docker/ci/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
ARCH  ?= x86_64,aarch64,ppc64le,s390x
all: runtime build document

login:
ifeq ($(CI_BUILD_TOKEN),)
	docker login $(CI_REGISTRY_IMAGE)
else
	docker login -u gitlab-ci-token -p $(CI_BUILD_TOKEN) $(CI_REGISTRY_IMAGE)
endif

runtime: builder
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/runtime:ubuntu2004 -f Dockerfile.ubuntu2004 . --target runtime
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/runtime:ubuntu2204 -f Dockerfile.ubuntu2204 . --target runtime
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/runtime:ubuntu2004-metis4 -f Dockerfile.ubuntu2004 . --target runtime
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/runtime:ubuntu2204-metis4 -f Dockerfile.ubuntu2204 . --target runtime
build: builder
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build:ubuntu2004 -f Dockerfile.ubuntu2004 . --target build
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build:ubuntu2004-metis4 -f Dockerfile.ubuntu2004 . --target build-metis4
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build:ubuntu2204 -f Dockerfile.ubuntu2204 . --target build
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build:ubuntu2204-metis4 -f Dockerfile.ubuntu2204 . --target build-metis4
document: builder
	docker buildx build --push --builder multiarch --platform x86_64 -t $(CI_REGISTRY_IMAGE)/document      -f Dockerfile.ubuntu2004      . --target document
builder:
	-docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
	-docker buildx create --name multiarch --driver docker-container

=== fistr1/src/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/analysis/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/common/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/lib/CMakeLists.txt)

=== fistr1/src/main/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr1_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/fistr_main.f90
  ${CMAKE_CURRENT_LIST_DIR}/main.c
)

=== hecmw1/src/common/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_hash.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_init.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_finalize.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_comm.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_conn_conv.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_error.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_util.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_malloc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_log.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg_table.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_lib_fc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_control.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ctrllex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_bit_array.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_map_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_set_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_varray_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_etype.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_debug_write_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_reorder.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_gflex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_heclex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ablex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_hec.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_abaqus.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_nastran_dummy.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_geofem.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_get_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_get_mesh_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_put_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_alloc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_print.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_free.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_f2c.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_c2f.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_refine.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ucd_print.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_geometric.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_path.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_put_mesh_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_restart.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_bin_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_copy_c2f.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_copy_f2c.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_io_bin.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_io_txt.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_visual_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_system.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_time.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_util_f.F90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_logging.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msgno_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_control_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_restart_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_f2c_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_c2f_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_free_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_print_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_visualizer_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_etype_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_varray_int_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io.f90
)

list(APPEND hecmw_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/tools/hec2rcap/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hec2rcap_SORUCES
  ${CMAKE_CURRENT_LIST_DIR}/hec2rcap.c
)

=== hecmw1/tools/result_type_converter/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND rconv_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_res_type_conv.c
)

=== fistr1/src/analysis/static/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Ctrl_TimeInc.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Cutback.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Spring.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Restart.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_NodalStress.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_StiffMatrix.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Update.f90
  ${CMAKE_CURRENT_LIST_DIR}/readtemp.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_echo.f90
  ${CMAKE_CURRENT_LIST_DIR}/make_result.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ass_load.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_output.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_mat_con_contact.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_Residual.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_AddContactStiff.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_AddBC.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_solve_NonLinear.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_solve_NLGEOM.f90
)

=== fistr1/tools/neu2fstr/converter/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND neu2fstr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/cconv_mat.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CConvMessage.cpp
  ${CMAKE_CURRENT_LIST_DIR}/conv_neu2hec.cpp
  ${CMAKE_CURRENT_LIST_DIR}/conv_neu2fstr_static.cpp
  ${CMAKE_CURRENT_LIST_DIR}/conv_neu2fstr_dynamic.cpp
  ${CMAKE_CURRENT_LIST_DIR}/conv_neu2fstr_heat.cpp
)

list(APPEND neu2fstr_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/src/operations/element_smoothing/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_es_mesh_connectivity.f90
)

=== hecmw1/src/operations/jacobian/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_Jacob_231.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_Jacob_241.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_Jacob_341.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_Jacob_361.f90
)

=== hecmw1/src/solver/main/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solver.f90
)

=== hecmw1/src/solver/precond/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/11/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/22/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/33/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/44/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/66/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/nn/CMakeLists.txt)

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_precond.f90
)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=frontistr
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.6
pkgrel=2
pkgdesc='Open-Source Large-Scale Parallel FEM Program for Nonlinear Structural Analysis (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.frontistr.com"
msys2_repository_url="https://github.com/frontistr/frontistr"
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-metis"
         # "${MINGW_PACKAGE_PREFIX}-mumps" Couldn't be found by cmake!
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             $([[ ${CARCH} == aarch64 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-msmpi" \
               "${MINGW_PACKAGE_PREFIX}-parmetis" \
               "${MINGW_PACKAGE_PREFIX}-scalapack" \
               "${MINGW_PACKAGE_PREFIX}-trilinos")
             "${MINGW_PACKAGE_PREFIX}-seacas")
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-fix-build-with-flang.patch")
sha256sums=('e818698f61c4482151e7aa9d27cabfa14c8c1643a99511ec45659b883e78c742'
            'd13265d210a5263485f6100334a9faa95139c120a16ef4202cc65d2e0ffe23b4')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-build-with-flang.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} != aarch64 ]]; then
    _extra_config+=("-DWITH_MPI=ON" "-DWITH_ML=ON")
  else
    _extra_config+=("-DWITH_MPI=OFF" "-DWITH_ML=OFF")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS="-fallow-invalid-boz"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
  
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR=${pkgdir} cmake --install .

  install -Dm644 ${srcdir}/${_realname}-${pkgver}/License.txt \
    ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE 

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}${MINGW_PREFIX}"/lib/cmake -type f); do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done
  
}
